import static org.junit.Assert.*;

import org.junit.Before;
import org.junit.Test;
import org.junit.runner.RunWith;
import greenfoot.junitUtils.runner.GreenfootRunner;
import greenfoot.junitUtils.*;

@RunWith(GreenfootRunner.class)
public class MyWorldTest {
    
    MyWorld world;
    Ball ball;
    
    @Before
    public void setUp() throws Exception {
        // GIVEN: The local variables are a world and its actor
        world = new MyWorld();
        ball = world.getObjects(Ball.class).get(0);
    }
    
    @Test
    public void testConstructor() throws Exception {
        // GIVEN: The local variable belongs to MyWorld class 
        MyWorld world;

        // WHEN : The action to test is the MyWorld constructor
        world = new MyWorld();
        
        // THEN : The asserts to verify are the number, in this case
        //        one, and position of the single Ball object.
        assertEquals(1, world.getObjects(Ball.class).size());
        assertEquals(2, world.getObjects(Ball.class).get(0).getX());
        assertEquals(1, world.getObjects(Ball.class).get(0).getY());
    }

    @Test
    public void testImage() throws Exception {
        // GIVEN: The local variable belongs to MyWorld class 
        greenfoot.GreenfootImage image = world.getBackground();

        // WHEN : The action to test is the MyWorld constructor
        String name = image.getImageFileName();
        
        // THEN : The asserts to verify are the number, in this case
        //        one, and position of the single Ball object.
        assertEquals("bluerock.jpg", name);
    }
    
    @Test
    public void testOtherWorld() throws Exception {
        // WHEN : The action to test is the key pressed
        EventDispatch.keyPressed("n");
        WorldCreator.runOnce(world);
               
        // THEN : The asserts to verify is that the ball is in new world
        assertEquals(OtherWorld.class, ball.getWorld().getClass());
    }
    
    @Test
    public void testOtherWorldBis() throws Exception {        
        // WHEN : The action to test is the key pressed
        EventDispatch.keyPressed("n");
        world.act();
               
        // THEN : The asserts to verify is that the ball is in new world
        assertEquals(OtherWorld.class, ball.getWorld().getClass());
    }
    
    @Test
    public void testOtherWorldBisBis() throws Exception {        
        // WHEN : The action to test is the key pressed
        EventDispatch.keyPressed("n");
        WorldCreator.runOnce();       
        
        // THEN : The asserts to verify is that the ball is in new world
        assertEquals(OtherWorld.class, ball.getWorld().getClass());
    }
    
}
