import static org.junit.Assert.*;

import org.junit.Before;
import org.junit.Test;
import org.junit.runner.RunWith;
import greenfoot.junitUtils.runner.GreenfootRunner;
import greenfoot.junitUtils.*;

@RunWith(GreenfootRunner.class)
public class OtherWorldTest {
    
    // Common variables to all tests are declared here.
    
    /**
     * Sets up the test fixture.
     * Called before every test case method.
     */
    @Before
    public void setUp() throws Exception {
        // Common variables to all tests are initialized here.
    }
    
    @Test
    public void testConstructor() throws Exception {
        // GIVEN: The local variable belongs to OtherWorld class 
        OtherWorld world;
        
        // WHEN : The action to test is the OtherWorld constructor
        Random.set(5, OtherWorld.class);
        Random.set(4, OtherWorld.class);
        world = new OtherWorld(new Ball());
        
        // THEN : The asserts to verify are the number, in this case
        //        one, and position of the single Ball object.
        assertEquals(1, world.getObjects(Ball.class).size());
        assertEquals(5, world.getObjects(Ball.class).get(0).getX());
        assertEquals(4, world.getObjects(Ball.class).get(0).getY());
    }  
    
    @Test
    public void testImage() throws Exception {
        // GIVEN: The local variable belongs to MyWorld class 
        OtherWorld world = new OtherWorld(new Ball());
        greenfoot.GreenfootImage image = world.getBackground();

        // WHEN : The action to test is the MyWorld constructor
        String name = image.getImageFileName();
        
        // THEN : The asserts to verify are the number, in this case
        //        one, and position of the single Ball object.
        assertEquals("bluerock.jpg", name);
    }
    
    @Test
    public void testTwoConsecutiveWorlds() throws Exception {        
        // GIVEN: The local variable belongs to OtherWorld class 
        Random.set(2, OtherWorld.class);
        Random.set(2, OtherWorld.class);
        Random.set(2, OtherWorld.class);
        OtherWorld firstWorld = WorldCreator.getWorld(OtherWorld.class, new Ball());
        OtherWorld secondWorld;
        
        // WHEN : The action to test is the OtherWorld constructor
        Random.set(5, OtherWorld.class);
        Random.set(4, OtherWorld.class);
        secondWorld = new OtherWorld(new Ball());
        
        // THEN : The asserts to verify are the number, in this case
        //        one, and position of the single Ball object.
        assertEquals(1, secondWorld.getObjects(Ball.class).size());
        assertEquals(5, secondWorld.getObjects(Ball.class).get(0).getX());
        assertEquals(4, secondWorld.getObjects(Ball.class).get(0).getY());
    }  
}
